/***************************************************************************
 *   Copyright (C) 2008 by Alvaro Garcia   								   *
 *   maxpowel@gmail.com   												   *
 *      														           *
 * 	 This file is part of AFEBL                                            *
 * 																		   *
 *   AFBL is free software; you can redistribute it and/or modify          *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with Foobar.  If not, see <http://www.gnu.org/licenses/>.       *
 ***************************************************************************/
#include "afeblbrowser.h"


AFEBLbrowser::AFEBLbrowser()
{
	this->header=new AFEBLcontainer();
	this->inputs=new AFEBLpostData();
	this->cookies=new AFEBLcookies();
}


AFEBLbrowser::~AFEBLbrowser()
{
	delete this->header;
}

void AFEBLbrowser::addInput(string inputName,string inputValue)
{
	this->inputs->add(inputName,inputValue);
}
bool AFEBLbrowser::modifyInput(string inputName,string newValue)
{
	return this->inputs->modify(inputName,newValue);
}
bool AFEBLbrowser::removeInput(string inputName)
{
	return this->inputs->remove(inputName);
}
string AFEBLbrowser::getInputValue(string inputName)
{
	return this->inputs->get(inputName);
}
void AFEBLbrowser::clearInputs()
{
	this->inputs->clear();
}
void AFEBLbrowser::showInputs()
{
	this->inputs->show();
}

void AFEBLbrowser::submit()
{
	
}

string AFEBLbrowser::get(string host)
{
	string path;
	int formSocket;
	string response;
	if(host.length()>0)
	{
		if(host.find("http://")==0)//Remove http://
		{
			host=host.substr(7,host.length()-7);
		}

		//Split the url to get the hostname and the path
		if(host.find("/")!=string::npos)
		{
			path=host.substr(host.find("/"),host.length()-host.find("/"));
			host=host.substr(0,host.length()-path.length());
		}
		else path="/"; //If path is no specified we use /
	
		formSocket = socket(AF_INET, SOCK_STREAM, 0);
		struct sockaddr_in serv_addr=AFEBLipResolver::getIpFrom(host);
	
		connect(formSocket,(const struct sockaddr*)&serv_addr,sizeof(struct sockaddr_in));
		
		//Build the header
		string texto="GET "+path+" HTTP/1.1\r\nHost: "+host+"\r\nUser-Agent: Mozilla/4.0\r\n"+this->cookies->buildCookies()+"\r\n";
		cout << texto;	
		write(formSocket,texto.c_str(),texto.length());

		char buffer[255];
 		bzero(buffer,255);
		while(recv(formSocket,buffer,255,0))//Non-blocking socket	
		{
			response.insert(response.length(),buffer);
			bzero(buffer,255);
		}
	}
	this->parseHTML(response);
	this->parseCookies(this->header->get("Set-Cookie"));
	this->header->clear();
	this->inputs->clear();
	return response;

}

string AFEBLbrowser::submit(string host)
{
	string path;
	int formSocket;
	string response;
	if(host.length()>0)
	{
		if(host.find("http://")==0)
		{
			host=host.substr(7,host.length()-7);
		}

		if(host.find("/")!=string::npos)
		{
			path=host.substr(host.find("/"),host.length()-host.find("/"));
			host=host.substr(0,host.length()-path.length());
		}
		else path="/";
		formSocket = socket(AF_INET, SOCK_STREAM, 0);
		struct sockaddr_in serv_addr=AFEBLipResolver::getIpFrom(host);
	
		connect(formSocket,(const struct sockaddr*)&serv_addr,sizeof(struct sockaddr_in));
		
		string texto="POST "+path+" HTTP/1.1\r\nHost: "+host+"\r\nUser-Agent: Mozilla/4.0\r\n"+this->inputs->build()+"\r\n";
		write(formSocket,texto.c_str(),texto.length());
		char buffer[255];
 		bzero(buffer,255);
		while(recv(formSocket,buffer,255,0))		
		{
			response.insert(response.length(),buffer);
			bzero(buffer,255);
		}
	}
	
	this->parseHTML(response);
	this->parseCookies(this->header->get("Set-Cookie"));
	this->header->clear();
	this->inputs->clear();
	return response;

}

void AFEBLbrowser::parseCookies(string html)
{
	const char *delimitator=";";
	char *tok;
	string aux;
	int pos;

	if(html.length()>0)
	{
		tok=strtok((char *)html.c_str(),delimitator);
		
		while(tok!=NULL)
		{
			aux=tok;
			pos=aux.find("=",0);
			if(pos!=string::npos)
				this->cookies->add(aux.substr(1,pos-1),aux.substr(pos+1,aux.length()-pos-1));
			tok=strtok(NULL,delimitator);
		}
	}
}
void AFEBLbrowser::parseHTML(string html)
{
	const char *delimitator="\n";
	char *tok;
	string aux;
	int pos;
	string header=html.substr(0,html.find("\r\n\r\n",0));
	tok=strtok((char *)header.c_str(),delimitator);
	while(tok!=NULL)
	{
		aux=tok;
		pos=aux.find(":",0);
		if(pos!=string::npos)
			this->header->add(aux.substr(0,pos),aux.substr(pos+1,aux.length()-pos-1));
		
		tok=strtok(NULL,delimitator);
	}
	
}

void AFEBLbrowser::clearCookies()
{
	this->cookies->clear();
}
